| Oyranos Colour Management System API

- Main Page
- Related Pages
- Modules
- Data Structures
- Files

- Data Structures
- Data Structure Index
- Class Hierarchy
- Data Fields

Public Member Functions | Data Fields
oyFilterCore_s Struct Reference
DAG and Image processing API

A basic filter to manipulate data. More...

`#include <oyFilterCore_s.h>`

Inheritance diagram for oyFilterCore_s:
Collaboration diagram for oyFilterCore_s:

## Public Member Functions
OYAPI oyFilterCore_s *OYEXPORT | oyFilterCore_New (oyObject_s object)
| allocate a new FilterCore object More...
OYAPI oyFilterCore_s *OYEXPORT | oyFilterCore_Copy (oyFilterCore_s *filtercore, oyObject_s object)
| copy or reference a FilterCore object More...
OYAPI int OYEXPORT | oyFilterCore_Release (oyFilterCore_s **filtercore)
| release and possibly deallocate a oyFilterCore_s object More...
const char * | oyFilterCore_GetCategory (oyFilterCore_s *filter, int nontranslated)
| Get category string. More...
const char * | oyFilterCore_GetName (oyFilterCore_s *filter, oyNAME_e name_type)
| Get name. More...
const char * | oyFilterCore_GetText (oyFilterCore_s *filter, oyNAME_e name_type)
| Get text. More...
oyFilterCore_s * | oyFilterCore_NewWith (const char *registration, oyOptions_s *options, oyObject_s object)
| Lookup and initialise a new filter object. More...
OYAPI const char *OYEXPORT | oyFilterCore_GetRegistration (oyFilterCore_s *filter)
| Get registration text. More...
Public Member Functions inherited from oyStruct_s
const char * | oyStruct_GetText (oyStruct_s *obj, oyNAME_e name_type, uint32_t flags)
| get a text dump More...

## Data Fields
oyStruct_Copy_f | copy
oyStruct_Release_f | release
Data Fields inherited from oyStruct_s
oyStruct_Copy_f | copy
oyStruct_Release_f | release

## Detailed Description

A basic filter to manipulate data.

This is the Oyranos filter object. Filters are categorised into basic classes of filters described in the registration_ (//xxx) member. Filters implement a container for data and options. Filters can be manipulated by changing their options or data set.

Filters are chained into a oyConversion_s in order to get applied to data. The relation of filters in a graph is defined through the oyFilterNode_s struct.

It is possible to chain filters in different ways together. The aimed way here is to use members and queries to find possible connections. For instance a one in one out filter can not be connected to two sources at once.

The registration_ describes different basic types of filters (//xxx). See oyranos::oyCONNECTOR_e.

Version
  Oyranos: 0.1.10

Since
  2008/06/08 (Oyranos: 0.1.8)

Date
  2009/11/17

## Member Function Documentation

OYAPI oyFilterCore_s *OYEXPORT oyFilterCore_Copy | ( | oyFilterCore_s * | filtercore,
|  | oyObject_s | object
| ) |  |

copy or reference a FilterCore object

Function oyFilterCore_Copy

The function is for copying and for referencing. The reference is the most often used way, which saves resourcs and time.

Parameters

  [in] | filtercore | FilterCore struct object
  | object | NULL - means reference, the optional object triggers a real copy

References oyOBJECT_FILTER_CORE_S.

Referenced by oyFilterNode_s::oyFilterNode_Create(), and oyFilterNode_s::oyFilterNode_GetCore().

const char * oyFilterCore_GetCategory | ( | oyFilterCore_s * | filter,
|  | int | nontranslated
| ) |  |

Get category string.

Function oyFilterCore_GetCategory

Parameters

  [in,out] | filter | filter object
  | nontranslated | switch for translation

Version
  Oyranos: 0.1.10

Since
  2008/06/26 (Oyranos: 0.1.8)

Date
  2009/02/28

Referenced by oyFilterGraph_s::oyFilterGraph_ToText().

const char * oyFilterCore_GetName | ( | oyFilterCore_s * | filter,
|  | oyNAME_e | name_type
| ) |  |

Get name.

Function oyFilterCore_GetName

provides the original filter names

Parameters

  [in,out] | filter | filter object
  | name_type | type of name

Version
  Oyranos: 0.1.10

Since
  2008/06/26 (Oyranos: 0.1.8)

Date
  2009/02/28

Referenced by oyFilterNode_s::oyFilterNode_Connect().

OYAPI const char *OYEXPORT oyFilterCore_GetRegistration | ( | oyFilterCore_s * | filter | ) |

Get registration text.

Function oyFilterCore_GetRegistration

Parameters

  [in] | filter | filter object

Returns
  registration string

Version
  Oyranos: 0.5.0

Date
  2012/10/04

Since
  2012/10/04 (Oyranos: 0.5.0)

const char * oyFilterCore_GetText | ( | oyFilterCore_s * | filter,
|  | oyNAME_e | name_type
| ) |  |

Get text.

Function oyFilterCore_GetText

oyNAME_NAME provides a XML element with child elements and attributes

Parameters

  [in,out] | filter | filter object
  | name_type | type of name

Version
  Oyranos: 0.1.10

Since
  2008/07/18 (Oyranos: 0.1.8)

Date
  2009/02/28

References oyNAME_NAME, oyProfile_s::oyProfile_GetText(), oyProfiles_s::oyProfiles_Count(), and oyProfiles_s::oyProfiles_Get().

Referenced by oyFilterNode_s::oyFilterNode_GetText().

OYAPI oyFilterCore_s *OYEXPORT oyFilterCore_New | ( | oyObject_s | object | ) |

allocate a new FilterCore object

Function oyFilterCore_New

References oyOBJECT_OBJECT_S.

oyFilterCore_s * oyFilterCore_NewWith | ( | const char * | registration,
|  | oyOptions_s * | options,
|  | oyObject_s | object
| ) |  |

Lookup and initialise a new filter object.

Function oyFilterCore_NewWith

back end selection:

- the user knows, which kind of filter is requested -> registration, e.g. "//color"
- the user probably knows, which special CMM to use (e.g. lcms, icc, shiva)

Parameters

  [in] | registration | the filter registration pattern
  [in] | options | the supplied filter options
  [in] | object | the optional object

Returns
  a filter core

Version
  Oyranos: 0.1.10

Since
  2008/06/24 (Oyranos: 0.1.8)

Date
  2009/07/27

References oyFilterCore_Release(), oyOBJECT_CMM_API4_S, and oyOptions_s::oyOptions_Copy().

Referenced by oyFilterNode_s::oyFilterNode_NewWith().

OYAPI int OYEXPORT oyFilterCore_Release | ( | oyFilterCore_s ** | filtercore | ) |

release and possibly deallocate a oyFilterCore_s object

Function oyFilterCore_Release

Parameters

  [in,out] | filtercore | FilterCore struct object

References oyOBJECT_FILTER_CORE_S.

Referenced by oyFilterCore_NewWith(), oyFilterGraph_s::oyFilterGraph_ToText(), oyFilterNode_s::oyFilterNode_NewWith(), and oyOptions_s::oyOptions_ForFilter().

## Field Documentation

oyStruct_Copy_f oyFilterCore_s::copy

copy function

oyStruct_Release_f oyFilterCore_s::release

release function